SoPickStyle(3)

NAME
SoPickStyle - The SoPickStyle class is a node for setting up how to do picking.

SYNOPSIS

#include <Inventor/nodes/SoPickStyle.h>

Inherits SoNode.

  Public Types
enum Style { SHAPE = SoPickStyleElement::SHAPE, BOUNDING_BOX = SoPickStyleElement::BOUNDING_BOX, UNPICKABLE = SoPickStyleElement::UNPICKABLE, SHAPE_ON_TOP = SoPickStyleElement::SHAPE_ON_TOP, BOUNDING_BOX_ON_TOP = SoPickStyleElement::BOUNDING_BOX_ON_TOP, SHAPE_FRONTFACES = SoPickStyleElement::SHAPE_FRONTFACES }

  Public Member Functions
virtual SoType getTypeId (void) const
SoPickStyle (void)
virtual void doAction (SoAction *action)
virtual void callback (SoCallbackAction *action)
virtual void pick (SoPickAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFEnum style

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoPickStyle ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoPickStyle class is a node for setting up how to do picking. By default, all geometry in a scene is available for picking. Upon writing applications with interaction possibilities, this is often not what you want. To exclude parts of the scene graph from pick actions, use the SoPickStyle::UNPICKABLE.

You can also optimize pick operations by using the SoPickStyle::BOUNDING_BOX pick style.

FILE FORMAT/DEFAULTS:

PickStyle {
    style SHAPE
}

See also
    SoRayPickAction

Member Enumeration Documentation

  enum SoPickStyle::Style
Enumeration of the available picking strategies.

Enumerator

SHAPE
    Do 'exact' picks, finding the correct intersection point(s), etc.

BOUNDING_BOX
    Only compare pick intersection with the bounding boxes of shapes. This is usually much faster than SoPickStyle::SHAPE.

UNPICKABLE
    The geometry following this node in the scene will not be available for picking.

SHAPE_ON_TOP
    Do exact picks, like SHAPE, but sort the shape to the front of the list of picked points so it appears to be the frontmost item. This does not affect the SoPickedPoint pick coordinate though, just the sorting by depth done on the picked point list.

Since
    Coin 3.0

BOUNDING_BOX_ON_TOP
    Do picks against the enclosing bounding box of the object, like BOUNDING_BOX, but sort the shape to the front of the list of picked points so it appears to be the frontmost item. This does not affect the SoPickedPoint pick coordinate though, just the sorting by depth done on the picked point list.

Since
    Coin 3.0

SHAPE_FRONTFACES
    Do exact picks, like SHAPE, but cull all the backface intersections from the list. Note that this logic is relative to the ray, not the view, in case the ray and the view direction are not aligned.

The behaviour of this setting will also depend on the SoShapeStyle vertexOrdering and shapeType setting, which are used to flip front faces to become back faces and vice versa and to turn backface culling on and off.

Since
    Coin 3.0

Constructor & Destructor Documentation

  SoPickStyle::SoPickStyle (void)
Constructor.

  SoPickStyle::~SoPickStyle () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoPickStyle::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoPickStyle::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

  const SoFieldData ** SoPickStyle::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoPickStyle::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoPickStyle::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoPickStyle::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

  void SoPickStyle::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

Member Data Documentation

  SoSFEnum SoPickStyle::style
Which strategy to use for the picking actions for subsequent shapes in the scene graph. Default value is SoPickStyle::SHAPE.

Author

Generated automatically by Doxygen for Coin from the source code.